#!/bin/sh
# 
# SamyGO ForceFirmwareBack v0.8.1 by juzis28
# last update on 02/06/2013
#
ver=0.8.1
set -e # urgent script exit if any command returns error
start=`date +%s`
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
echo "========================Start FFB!!!========================"
touch /dtv/script_start
# search for USB
if [ -e /dtv/usb/sda1 ]; then
		USB=/dtv/usb/sda1

elif [ -e /dtv/usb/sda ]; then
        USB=/dtv/usb/sda

elif [ -e /dtv/usb/sda0 ]; then
        USB=/dtv/usb/sda0

elif [ -e /dtv/usb/sda2 ]; then
        USB=/dtv/usb/sda2

elif [ -e /dtv/usb/sdb ]; then
        USB=/dtv/usb/sdb

elif [ -e /dtv/usb/sdc ]; then
        USB=/dtv/usb/sdc

elif [ -e /dtv/usb/sdb1 ]; then
        USB=/dtv/usb/sdb1

elif [ -e /dtv/usb/sdc1 ]; then
        USB=/dtv/usb/sdc1
else
	echo "[`date +%H:%M:%S`] No valid USB found. Script stop. Exit. Rebooting..."
	touch /dtv/NO_USB    # Flag file for screen message - no USB found
	sleep 10
	exit 2
fi

#set function for reboot on error and on script exit/end
_FUNC_ERROR ()
{
echo "[`date +%H:%M:%S`] Reboot on error or script end." #>> $FFBLOG 2>&1 
	/mtd_boot/MicomCtrl 143  
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
	/mtd_boot/MicomCtrl 143
}
trap _FUNC_ERROR EXIT

#Check USB filesystem. Only Fat32 is ok.
if [ `mount | grep $USB | grep -c "type ntfs"` == 1 ]; then
		touch /dtv/0_wrong_usb_fs    # flag file for screen message - wrong usb file system (NTFS)
		echo "Wrong USB file system. Fat32 is needed. . . ! ! !"
		sleep 10
		error
fi 

########################## variables ########################

FFBLOG=$USB/_FFBlog.log
SYSLOG=$USB/_sysinfo.log


#kill watchdog 
/mtd_boot/MicomCtrl 23 
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23
/mtd_boot/MicomCtrl 23

#script debug
export PS4='+'
exec > $USB/_debug.log
exec 2>&1
set -x # debug script file to _debug.log
#

#Cleaning /mtd_swu/, ignore errors
set +e
echo "[`date +%H:%M:%S`] cleaning /mtd_swu/" 
rm -rf /mtd_swu/* 
echo "[`date +%H:%M:%S`] /mtd_swu/ cleaned." 
set -e
# Collecting system information
echo "==========FFB ver. $ver by juzis28=========="> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "==========Some important system information==========">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
cat /.info >> $FFBLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "========================mount=======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	mount >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "========================df -h=======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	df -h >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "===================PartitionSwitch*=================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	ls -l /mtd_rwarea/PartitionSwitch* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "======================Version*======================">> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	ls -l /mtd_rwarea/Version* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
	cat /mtd_rwarea/Version* >> $SYSLOG 2>&1 
echo " " >> $SYSLOG 2>&1 
echo "=========================end========================" >> $SYSLOG 2>&1


echo "==============FFB ver. $ver by juzis28=============="> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1 
echo "=====================Script start====================" >> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1 
echo "USB found: $USB"
echo "[`date +%H:%M:%S`] USB found: $USB" >> $FFBLOG 2>&1 

# search for directory
if [ -d $USB/T-CHL7DEUC ]; then
	firmware_usb=T-CHL7DEUC
	image_dir=$firmware_usb/image
	echo "[`date +%H:%M:%S`] Directory found: $USB/$firmware_dir"  >> $FFBLOG 2>&1 
elif [ -d $USB/T-CHU7DEUC ]; then
	firmware_usb=T-CHU7DEUC
	image_dir=$firmware_usb/image
	echo "[`date +%H:%M:%S`] Directory found: $USB/$firmware_dir"  >> $FFBLOG 2>&1 
elif [ -d $USB/T-CHEAUSC ]; then
	firmware_usb=T-CHEAUSC
	image_dir=$firmware_usb/image
	echo "[`date +%H:%M:%S`] Directory found: $USB/$firmware_dir"  >> $FFBLOG 2>&1 
elif [ -d $USB/T-CHE7AUSC ]; then
	firmware_usb=T-CHE7AUSC
	image_dir=$firmware_usb/image
	echo "[`date +%H:%M:%S`] Directory found: $USB/$firmware_dir"  >> $FFBLOG 2>&1 
elif [ -d $USB/T-CHEAKRC ]; then
	firmware_usb=T-CHEAKRC
	image_dir=$firmware_usb/image
	echo "[`date +%H:%M:%S`] Directory found: $USB/$firmware_dir"  >> $FFBLOG 2>&1 
else
	echo "[`date +%H:%M:%S`] No firmware on USB found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
	touch /dtv/1_no_fw_on_usb    # 1 flag file for screen message - no firmware on usb / wrong firmware
	sleep 10
	_FUNC_ERROR
fi

########################## variables ########################
FFBLOG=$USB/_FFBlog.log
SYSLOG=$USB/_sysinfo.log

EXE_PART0=/dev/bml0/8
EXE_PART1=/dev/bml0/10
EXE_DEPO=/mtd_swu/exe.img
APPDATA_PART0=/dev/bml0/9
APPDATA_PART1=/dev/bml0/11
APPDATA_DEPO=/mtd_swu/appdata.img
UBOOT_DEPO=/mtd_swu/[$firmware_usb]-u-boot.bin
FNW_DEPO=/mtd_swu/[$firmware_usb]-fnw.bin
KERNEL_DEPO=/mtd_swu/[$firmware_usb]-Image

EXE_PART=""
APPDATA_PART=""
VERSION=""
VERSION_ALT=""
PART_FLAG=""
PART_FLAG_ALT=""




#Check files on USB
		echo " " >> $FFBLOG 2>&1
		echo "==================================================================" >> $FFBLOG 2>&1
		echo "#Check files on USB " >> $FFBLOG 2>&1
		echo "Content of $USB:" >> $FFBLOG 2>&1
		ls -la $USB >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		echo "==================================================================" >> $FFBLOG 2>&1
		echo "Content of $USB\/$firmware_usb\/:" >> $FFBLOG 2>&1
		ls -la $USB/$firmware_usb >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		echo "==================================================================" >> $FFBLOG 2>&1
		echo "Content of $USB\/$firmware_usb\/image:" >> $FFBLOG 2>&1
		ls -la $USB/$firmware_usb/image >> $FFBLOG 2>&1
		echo " " >> $FFBLOG 2>&1
		echo "==================================================================" >> $FFBLOG 2>&1



# Check for active firmware flag and partitions.
if  [ -e /mtd_rwarea/PartitionSwitch_0_0 ]
    then
		VERSION=/mtd_rwarea/Version.0
		VERSION_ALT=/mtd_rwarea/Version.1
		PART_FLAG=/mtd_rwarea/PartitionSwitch_0_0
		PART_FLAG_ALT=/mtd_rwarea/PartitionSwitch_1_0
		EXE_PART=$EXE_PART1
		APPDATA_PART=$APPDATA_PART1
			echo "Some important data" >> $FFBLOG 2>&1
			echo " " >> $FFBLOG 2>&1
			echo "VERSION is $VERSION" >> $FFBLOG 2>&1
			echo "VERSION_ALT is $VERSION_ALT" >> $FFBLOG 2>&1
			echo "PART_FLAG is $PART_FLAG" >> $FFBLOG 2>&1
			echo "PART_FLAG_ALT is $PART_FLAG_ALT" >> $FFBLOG 2>&1		
			echo "EXE_PART is $EXE_PART" >> $FFBLOG 2>&1
			echo "APPDATA_PART is $APPDATA_PART" >> $FFBLOG 2>&1
			echo " " >> $FFBLOG 2>&1
			if  [ -e /mtd_rwarea/PartitionSwitch_1_0 ]
				then
					echo "Found PartitionSwitch_0_0 and PartitionSwitch_1_0."  >> $FFBLOG 2>&1 
						rm -rf /mtd_rwarea/PartitionSwitch_1_0
					echo "PartitionSwitch_1_0 deleted." >> $FFBLOG 2>&1 
				else
					echo "Found PartitionSwitch_0_0 only" >> $FFBLOG 2>&1 
			fi
	else
		if  [ -e /mtd_rwarea/PartitionSwitch_1_0 ]
			then
				VERSION=/mtd_rwarea/Version.1
				VERSION_ALT=/mtd_rwarea/Version.0
				PART_FLAG=/mtd_rwarea/PartitionSwitch_1_0
				PART_FLAG_ALT=/mtd_rwarea/PartitionSwitch_0_0
				EXE_PART=$EXE_PART0
				APPDATA_PART=$APPDATA_PART0
					echo "Some important data" >> $FFBLOG 2>&1
					echo " " >> $FFBLOG 2>&1
					echo "VERSION is $VERSION" >> $FFBLOG 2>&1
					echo "VERSION_ALT is $VERSION_ALT" >> $FFBLOG 2>&1
					echo "PART_FLAG is $PART_FLAG" >> $FFBLOG 2>&1
					echo "PART_FLAG_ALT is $PART_FLAG_ALT" >> $FFBLOG 2>&1		
					echo "EXE_PART is $EXE_PART" >> $FFBLOG 2>&1
					echo "APPDATA_PART is $APPDATA_PART" >> $FFBLOG 2>&1
					echo " " >> $FFBLOG 2>&1
		fi
fi


#Check deeper to avoid flashing from renamed directory 
if [ $( grep -c $firmware_usb $USB/$image_dir/info.txt ) -gt 0 ]
then 
	 firmware_dir=$firmware_usb
     echo "[`date +%H:%M:%S`] Found: $firmware_usb firmware on USB." >> $FFBLOG 2>&1
else
	touch /dtv/3_fw_mismatch    # flag file for screen message - no firmware on usb / wrong firmware
	echo "[`date +%H:%M:%S`] Did you rename firmware directory??? Do not do it in future, you brick your TV! Firmware mismatch! quit."  >> $FFBLOG 2>&1 
	sleep 10
	error
fi

#Check firmware on USB is compatible?
if [ $( grep -c $firmware_usb $USB/$image_dir/info.txt ) == $(grep -c $firmware_usb $VERSION ) ]
then
    firmware_dir=$firmware_usb
	touch /dtv/2_fw_ok # 2 flag file for screen message - firmware ok.
    echo "[`date +%H:%M:%S`] Firmware on USB mach to firmware on TV. Going to upgrade..." >> $FFBLOG 2>&1
else
	touch /dtv/3_fw_mismatch #3 flag file for screen message - firmware missmatch
    echo "[`date +%H:%M:%S`] Wrong firmware on USB. Firmware mismatch. No firmware on USB?"
	sleep 10
	_FUNC_ERROR
fi

#find current script dir by script name (/ffb.sh - minus 7 char).
#CUR_DIR=$( echo ${0} | sed 's/\(.*\)......./\1/' ) 
if [ -d /mtd_tlib/swf/CHILDREN/firmware/1.FFB ]; then
CUR_DIR=/mtd_tlib/swf/CHILDREN/firmware/1.FFB
elif [ -d /mtd_tlib/swf/OTHER/firmware/1.FFB ]; then
CUR_DIR=/mtd_tlib/swf/OTHER/firmware/1.FFB
fi

echo "Current script dir is $CUR_DIR " >> $FFBLOG 2>&1

#Search for md5sum - tool for md5 calculations
echo "Checking md5sum binary..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/tools/md5sum ];	then
		echo "md5sum found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/tools/md5sum >> $FFBLOG 2>&1
	else
		echo "ERROR. md5sum not found. Script stop. Exit!" >> $FFBLOG 2>&1
		touch /dtv/4_no_md5sum # flag file for message
		sleep 10
		_FUNC_ERROR
fi

#Search for crc - tool for checksum calculations
echo "Checking crc binary..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/tools/crc ];	then
		echo "crc found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/tools/crc >> $FFBLOG 2>&1
	else
		echo "ERROR. crc not found!" >> $FFBLOG 2>&1
		touch /dtv/4_no_crc # flag file for message
		sleep 10
		_FUNC_ERROR
fi

#Search for ddcmp - tool for deXOR images and write to TV
echo "Checking ddcmp binary..." >> $FFBLOG 2>&1
if [ -e $CUR_DIR/tools/ddcmp ];	then
		echo "ddcmp found!" >> $FFBLOG 2>&1
		chmod 755 $CUR_DIR/tools/ddcmp >> $FFBLOG 2>&1
	else
		echo "ERROR. ddcmp not found!" >> $FFBLOG 2>&1
		touch /dtv/4_no_ddcmp # flag file for message
		sleep 10
		_FUNC_ERROR
fi
touch /dtv/4_tools_ok
#Find firmware number on USB
fw_nr=$( cat $USB/$image_dir/info.txt  | sed 's/^.*\(......\)$/\1/' )
echo "Firmware on USB is $firmware_usb-$fw_nr ">> $FFBLOG 2>&1

#copy to DEPO u-boot.bin, Image and fnw.bin and checking md5 sums. 
cp -f $USB/$image_dir/[$firmware_usb]-Image /mtd_swu/
cp -f $USB/$image_dir/[$firmware_usb]-fnw.bin /mtd_swu/
cp -f $USB/$image_dir/[$firmware_usb]-u-boot.bin /mtd_swu/
cp -f $USB/$image_dir/md5 /mtd_swu/
cd /mtd_swu
echo "[`date +%H:%M:%S`] checking checksums of three images..." >> $FFBLOG 2>&1
touch /dtv/md5_start
FILES=$(ls /mtd_swu | grep $firmware_usb)
for i in $FILES ;do $CUR_DIR/tools/md5sum $i; done > /mtd_swu/temp.md5
echo " " >>$FFBLOG
cat /mtd_swu/md5 >> $FFBLOG 2>&1
echo " " >> $FFBLOG
cat /mtd_swu/temp.md5 >> $FFBLOG 2>&1
echo " " >> $FFBLOG

if [ $( $CUR_DIR/tools/md5sum -c /mtd_swu/md5 | grep -c "OK" ) -ne 3 ];then
	echo "[`date +%H:%M:%S`] md5 error! Wrong images for uboot, kernel and fnw?" >> $FFBLOG 2>&1 
	touch /dtv/md5_wrong
	sleep 10
	_FUNC_ERROR
else
touch /dtv/md5_ok
echo "three images md5 are ok!" >> $FFBLOG 2>&1
fi
cd /
		
#Restoring bml0/2, 4, 5
if [ -e $USB/$image_dir/[$firmware_usb]-u-boot.bin ]
then
	echo "START updating u-boot.bin"
	touch /dtv/u_boot_start
	echo "[`date +%H:%M:%S`] START updating u-boot.bin"	 >> $FFBLOG 2>&1 
		bml.restore /dev/bml0/2 $UBOOT_DEPO  > $USB/[$firmware_usb]u-boot.log 2>&1
		sync
	echo "[`date +%H:%M:%S`] END updating u-boot.bin" >> $FFBLOG 2>&1 
	touch /dtv/u_boot_ok # message after bml0/2
	echo "END updating u-boot.bin"
  else
	echo "[`date +%H:%M:%S`] No u-boot found. Not from this model? Error"	 >> $FFBLOG 2>&1 
	touch /dtv/no_u_boot # message error
	sleep 10
	_FUNC_ERROR
fi

if [ -e $USB/$image_dir/[$firmware_usb]-fnw.bin ]
then
	echo "START updating fnw.bin"
	touch /dtv/fnw_start
	echo "[`date +%H:%M:%S`] START updating fnw.bin">> $FFBLOG 2>&1
		bml.restore /dev/bml0/4 $FNW_DEPO  > $USB/[$firmware_usb]fnw.log 2>&1
		sync
	echo "[`date +%H:%M:%S`] END updating fnw.bin" >> $FFBLOG 2>&1 
	touch /dtv/fnw_ok # message after bml0/4
	echo "END updating fnw.bin"	
  else
	echo "[`date +%H:%M:%S`] No fnw found or not from this model? Error"	 >> $FFBLOG 2>&1 
	touch /dtv/no_fnw # message error fnw
	sleep 10
	_FUNC_ERROR
fi
if [ -e $USB/$image_dir/[$firmware_usb]-Image ] 
then
	echo "START updating Image"
	touch /dtv/Image_start
	echo "[`date +%H:%M:%S`] START updating Image" >> $FFBLOG 2>&1 
		bml.restore /dev/bml0/5 $KERNEL_DEPO > $USB/[$firmware_usb]Image.log 2>&1
		sync
	echo "[`date +%H:%M:%S`] END updating Image"	>> $FFBLOG 2>&1 
	touch /dtv/Image_ok # message after bml0/5
	echo "END updating Image"
  else
	echo "[`date +%H:%M:%S`] No Image found or not from this model? Error"	 >> $FFBLOG 2>&1 
	touch /dtv/no_Image # message error Image
	sleep 10
	_FUNC_ERROR	
fi

#Start upgrade partitions
# Search for inactive firmware partitions and rewrite it. Set alternative fw active.

if [ -e $USB/$image_dir/exe.img.enc ]; 	then
#decrypting exe.img to /mtd_swu
	echo "[`date +%H:%M:%S`] exe.img.enc found on $USB, start copying..." >> $FFBLOG 2>&1 
	touch /dtv/exe_decrypt_start # message before exe.img
	$CUR_DIR/tools/ddcmp -F -e $firmware_dir -i $USB/$image_dir/exe.img.enc -o $EXE_DEPO  >> $FFBLOG 2>&1
	touch /dtv/exe_decrypt_ok
	echo "[`date +%H:%M:%S`] exe.img decrypted and copied to mtd_swu..." >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1				
	
#crc check of exe.img
	touch /dtv/exe_crc_start
	$CUR_DIR/tools/crc $EXE_DEPO $USB/$image_dir/validinfo.txt
		if [ $? -ne 0 ] ; then echo "[`date +%H:%M:%S`] checksum error! Try another USB pen drive."  >> $FFBLOG 2>&1 && touch /dtv/exe_crc_error && _FUNC_ERROR;fi
			echo "[`date +%H:%M:%S`] exe.img checksum ok" >> $FFBLOG 2>&1					
			touch /dtv/exe_crc_ok
			
#flashing exe.img
	echo "########## Flashing exe.img (CI)##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] Start flashing to $EXE_PART "  >> $FFBLOG 2>&1 
	touch /dtv/exe_flash_start 
	bml.restore $EXE_PART $EXE_DEPO > $USB/[$firmware_usb]exe_img.log 2>&1
	touch /dtv/exe_flash_ok
	echo "[`date +%H:%M:%S`] $EXE_PART restored. Deleting source..."  >> $FFBLOG 2>&1 
	rm -rf $EXE_DEPO
	echo "[`date +%H:%M:%S`] exe.img deleted from /mtd_swu/"  >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync
			else
				echo "ERROR. exe.img.enc not found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
				touch /dtv/exe_img_error # message on error
				_FUNC_ERROR
fi
		
if [ -e $USB/$image_dir/appdata.img.enc ];	then
#decrypting CI image and copying to mtd_swu
				echo "[`date +%H:%M:%S`] appdata.img.enc found on $USB, start copying..." >> $FFBLOG 2>&1 
				touch /dtv/appdata_decrypt_start # message before appdata.img
					$CUR_DIR/tools/ddcmp -F -e $firmware_dir -i $USB/$image_dir/appdata.img.enc -o $APPDATA_DEPO  >> $FFBLOG 2>&1
				echo "[`date +%H:%M:%S`] appdata.img decrypted and copied to mtd_swu..." >> $FFBLOG 2>&1 
				touch /dtv/appdata_decrypt_ok
				echo " " >> $FFBLOG 2>&1

#crc check of appdata.img	
					touch /dtv/appdata_crc_start
					$CUR_DIR/tools/crc $APPDATA_DEPO $USB/$image_dir/validinfo.txt
					if [ $? -ne 0 ] ; then echo "[`date +%H:%M:%S`] checksum error! Try another USB pen drive." >> $FFBLOG 2>&1 && touch /dtv/appdata_crc_error && _FUNC_ERROR;fi
					echo "[`date +%H:%M:%S`] appdata.img checksum ok" >> $FFBLOG 2>&1
						touch /dtv/appdata_crc_ok
					
#flashing appdata.img
	echo "########## Flashing appdata.img (CI)##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	echo "[`date +%H:%M:%S`] Start flashing to $APPDATA_PART "  >> $FFBLOG 2>&1 
	touch /dtv/appdata_flash_start
	bml.restore $APPDATA_PART $APPDATA_DEPO > $USB/[$firmware_usb]appdata_img.log 2>&1
	touch /dtv/appdata_flash_ok 
	echo "[`date +%H:%M:%S`] $APPDATA_PART restored. Deleting source..."  >> $FFBLOG 2>&1 
	rm -rf $APPDATA_DEPO >> $FFBLOG 2>&1 
	echo "[`date +%H:%M:%S`] appdata.img deleted from /mtd_swu/"  >> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync
			else
				echo "ERROR. appdata.img.enc not found. Script stop. Exit. Rebooting..." >> $FFBLOG 2>&1 
				touch /dtv/appdata_img_error # message on error
				_FUNC_ERROR
fi

#Toggle - if all ok, activate alternative firmware
	echo "########## Switching to alternative firmware ##########" >> $FFBLOG 2>&1
	echo " " >> $FFBLOG 2>&1
	touch $PART_FLAG_ALT 				>> $FFBLOG 2>&1 
	echo "$PART_FLAG_ALT created." 		>> $FFBLOG 2>&1 
	echo "Writing firmware ID to $VERSION_ALT..." >> $FFBLOG 2>&1 
		cat $USB/$image_dir/version_info.txt > $VERSION_ALT >> $FFBLOG 2>&1 
			if [ -e /mtd_rwarea/Version_1_SIG ] ; then
					cat $USB/$image_dir/version_info.txt > /mtd_rwarea/Version_1_SIG >> $FFBLOG 2>&1
					echo "Version_1_SIG created." >> $FFBLOG 2>&1 
			fi
	echo "$VERSION_ALT created" >> $FFBLOG 2>&1 
	rm -rf $PART_FLAG
	touch /dtv/toggle_ok
	echo "$PART_FLAG removed."		>> $FFBLOG 2>&1 
	echo " " >> $FFBLOG 2>&1
		sync

############ Finito ############
echo " " >> $FFBLOG 2>&1
touch /dtv/5_end_ok # message procedure finish
echo "USB update end !!!" >> $FFBLOG 2>&1 
echo "USB update end !!!"
sleep 10

#clean /mtd_swu
set +e
echo "cleaning /mtd_swu/" 
rm -rf /mtd_swu/* 
echo "/mtd_swu/ cleaned." 
set -e

echo " " >> $FFBLOG 2>&1
end=`date +%s`
diff=`expr $end - $start`
echo "========================">> $FFBLOG 2>&1 
echo "|Duration = $diff seconds|">> $FFBLOG 2>&1 
echo "========================">> $FFBLOG 2>&1 
echo " " >> $FFBLOG 2>&1
echo "Welcome to pre-FEB world !!!" >> $FFBLOG 2>&1 
echo "========================FFB end !!!========================"
echo "========================FFB end !!!========================"
echo "========================FFB end !!!========================"
echo " " >> $FFBLOG 2>&1
echo "TV is rebooting right now. Bye :)" >> $FFBLOG 2>&1 
/mtd_boot/MicomCtrl 143  
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143
/mtd_boot/MicomCtrl 143