﻿var MAX_MENU_NUM = 1;
var puPrevFocusObj = null;
var callbackFunc = null;
var gPopupInstance = null;
var gPopupTimer = false;
var TIMER_SET = 1000;
var TIMER_RESET = 1001;

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
function openPopup (requestedMsg, requestedFunc, requestedTime, buttonStr0, buttonStr1) {
	if ((requestedMsg != null) && (requestedFunc != null)) {
		alert ("openPopup("+requestedMsg+","+requestedTime+")");
		callbackFunc = requestedFunc;
		setPopupWindow (requestedMsg.length);
		
		if ((buttonStr0 == null)&&(buttonStr1 == null)) {
			createPopupHtml (requestedMsg, 1);
            document.getElementById("popupOneBTHelp").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 == null)) {
			createPopupHtml (requestedMsg, 1, buttonStr0);
            document.getElementById("popupOneBTHelp").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 != null)) {
			createPopupHtml (requestedMsg, 2, buttonStr0, buttonStr1);
            document.getElementById("popupTwoBTHelp").style.visibility =  "visible";            
        }

		popupTimerProcess (TIMER_SET, requestedTime);
		turnPopup("on");
		document.getElementById("popupButton0").focus();
		alert ("openPopup("+requestedMsg+","+requestedTime+") Ends.");
	}
}

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
function openPopupFocus(requestedMsg, requestedFunc, requestedTime, buttonStr0, buttonStr1) {
	if ((requestedMsg != null) && (requestedFunc != null)) {
		alert ("openPopupFocus("+requestedMsg+","+requestedTime+")");
		callbackFunc = requestedFunc;
		setPopupWindow (requestedMsg.length);
		
		if ((buttonStr0 == null)&&(buttonStr1 == null)) {
			createPopupHtml (requestedMsg, 1);
            document.getElementById("popupOneBTHelp").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 == null)) {
			createPopupHtml (requestedMsg, 1, buttonStr0);
            document.getElementById("popupOneBTHelp").style.visibility =  "visible";
        } else if ((buttonStr0 != null) && (buttonStr1 != null)) {
			createPopupHtml (requestedMsg, 2, buttonStr0, buttonStr1);
            document.getElementById("popupTwoBTHelp").style.visibility =  "visible";            
        }
		
		popupTimerProcess (TIMER_SET, requestedTime);
		turnPopup("on");
		document.getElementById("popupButton1").focus();
		alert ("openPopupFocus("+requestedMsg+","+requestedTime+") Ends.");
	}
}

/**
 * @brief			팝업을 연다
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
function openPopupNoBt(requestedMsg, requestedFunc, requestedTime) {
	if ((requestedMsg != null) && (requestedFunc != null)) {
		callbackFunc = requestedFunc;
		setPopupWindow (requestedMsg.length);

        createPopupHtml(requestedMsg, 0);
		
		popupTimerProcess (TIMER_SET, requestedTime);
		turnPopup("on");
		document.getElementById("noBt").focus();
	}
}

function popupTimerProcess (mode, timer) {
	alert ("popupTimerProcess("+mode +"," + timer+")");
	switch (mode) {
		case TIMER_SET :
			if (timer > 0 && timer != null) {
				gPopupTimer = eval(timer) * 1000;
				resetCloseTimer ();
			}
			else {
				gPopupTimer = false;
			}
			break;
		case TIMER_RESET :
			if (gPopupTimer != false)
				resetCloseTimer ();
			break;
		default:
			break;
	}
	alert ("popupTimerProcess("+mode +"," + timer+") Ends.");
}

function resetCloseTimer () {
	if (gPopupInstance != null) 
		clearTimeout(gPopupInstance);
	gPopupInstance = setTimeout("closePopup()", gPopupTimer);
}

/**
 * @brief			팝업을 닫는다.
 * @remarks		지정된 사이즈로 화면 중앙에 팝업을 생성한다.
* @param		void
* @return		void
*/
function closePopup (optionButton) {
	alert ("closePopup()");
	turnPopup ("off");
	if (callbackFunc)
		callbackFunc(-1);
	alert ("closePopup() Ends.");
}

/**
 * @brief			팝업 보이기/감추기
 * @remarks		팝업을 option에 따라 보이거나 감춘다
* @param		option		on/off option
* @return		void
*/
function turnPopup(option) {
	alert ("turnPopup("+option+")");
	if (option == "on") {
		document.getElementById ("popupDiv").style.visibility = "visible";
	} else if (option == "off") {
		document.getElementById ("popupDiv").style.visibility = "hidden";
        	document.getElementById("popupOneBTHelp").style.visibility =  "hidden";            
        	document.getElementById("popupTwoBTHelp").style.visibility =  "hidden";            
	if (gPopupInstance != null) clearTimeout (gPopupInstance);
	}
	alert ("turnPopup("+option+") Ends.");
}

/**
 * @brief			팝업 버튼에 포커스가 있을 때 화면 처리
 * @remarks		팝업 버튼 바탕에 이미지를 배경으로 깔아서 포커스 효과를 나타낸다.
* @param		obj		HTML Object
* @return		void
*/
function popupFocus (obj) {
//	alert ("popupFocus(obj)");
	obj.style.backgroundImage = "url('img/button_yes.png')";
}

/**
 * @brief			팝업 버튼에서 포커스를 벗어날 때 화면 처리
 * @remarks		팝업 버튼 바탕에 이미지를 없애고 투명하게 만든다.
* @param		obj		HTML Object
* @return		void
*/
function popupBlur (obj) {
//	alert ("popupBlur(obj)");
	obj.style.backgroundImage = "url('img/button_no.png')";
}

/**
 * @brief			팝업에서의 key 처리
 * @remarks		팝업에서 사용되는 키에 따른 action을 지정한다.
* @param		obj		HTML Object
* @return		void
*/
function popupKeyDown (obj) {
	var ie = (document.all) ? 1:0
	if (ie) { var EKC = event.keyCode;}

	var Idx = obj.name;
	Idx = eval(Idx);
	var tmpMenu;
	switch (EKC) {
		case(39) : // Right
		case(5) :
        case(29469): // remocon wheel right
        case(160): // 패널 키 Right
			if(bMaple && EKC==39) return false;
			if (Idx < MAX_MENU_NUM) {
                 Idx+=1;
            } else {
                Idx = 0;
            }
            alert("Idx : " + Idx);
			document.getElementById ("popupButton"+Idx).focus();
			popupTimerProcess (TIMER_RESET);
			break;
		
		case (37) : // Left
		case (4) :
        case(29468): // remocon wheel left
        case(161): // 패널 키 Left
			if(bMaple && EKC==37) return false;
			if (Idx > 0) {
            	Idx-=1;
            } else {
                Idx = MAX_MENU_NUM;
            }
            alert("Idx : " + Idx);
			document.getElementById ("popupButton"+Idx).focus();
			popupTimerProcess (TIMER_RESET);
			break;
		
		case (13) : //Enter
        case (29443) : 
        case(164): // 패널 키 Enter
			if(bMaple && EKC==13) return false;
			turnPopup ("off");
            //logic 처리 부분
			if (callbackFunc)
				callbackFunc(Idx);
			break;
			
        case (27) :
        case (88) : //ESC Key
        case(163): // 패널 키 ESC
        case (45): //Exit Key
        	if(bMaple && EKC==27) return false;
            blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
			closePopup();
       		break;
	}
}

/**
 * @brief			팝업에서의 key 처리
 * @remarks		팝업에서 사용되는 키에 따른 action을 지정한다.
* @param		obj		HTML Object
* @return		void
*/
function popupNoBTKeyDown(obj) {
	var ie = (document.all) ? 1:0
	if (ie) { var EKC = event.keyCode;}
    
    alert("popupNoBTKeyDown() : " + EKC);
    
    blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
    return;

//	switch (EKC) {
//		case(39) : // Right
//		case(5) :
//        case(29469): // remocon wheel right
//        case(160): // 패널 키 Right
//		break;
//		
//		case (37) : // Left
//		case (4) :
//        case(29468): // remocon wheel left
//        case(161): // 패널 키 Left
//		break;
//		
//		case (13) : //Enter
//        case (29443) : 
//        case(164): // 패널 키 Enter
//			if(bMaple && EKC==13) return false;
//		break;
//			
//        case (27) :
//        case (88) : //ESC Key
//        case(163): // 패널 키 ESC
//        case (45): //Exit Key
//        	if(bMaple && EKC==27) return false;
//            blockNavigation(event); // N.Navi 에서 복귀 이벤트 받지 못하게 한다
//        break;
//	}
}

/**
 * @brief			팝업의 위치, 크기 Setting
 * @remarks		메세지의 길이를 통하여 창의 크기와 위치를 Setting 한다.
 * @param		msgLength		메세지 창에 띄울 문구의 길이
 * @return		void
*/
function setPopupWindow (msgLength) {
	//alert ("setPopupWindow (msgLength)");
	var msgLength = msgLength;
	var popupHeight;
	
	popupHeight = 150 + Math.floor(msgLength/20)*10;
	var popupWidth = 516; // Hard Coding
	//alert ("Popup(width,height)=("+popupWidth+","+popupHeight+")");
	
	var popupLeftPos = Math.floor ((960-popupWidth) / 2);
	var popupTopPos = Math.floor ((540-popupHeight) / 2);
	
	//document.getElementById ("popupDiv").style.position = "absolute";
	document.getElementById ("popupDiv").style.left = popupLeftPos;
	document.getElementById ("popupDiv").style.top = popupTopPos;
	document.getElementById ("popupDiv").style.height = popupHeight;
	//document.getElementById ("popupDiv").style.width = popupWidth;
}

/**
 * @brief			팝업의 Html 구성
 * @remarks		팝업의 Html을 입력 인수들을 이용하여 동적으로 구성
* @param		requestedMsg		메세지 창에 띄울 문구
* @param		numOfButton		버튼의 갯수
* @param		buttonStr0		첫번째 버튼 이름
* @param		buttonStr1		두번째 버튼 이름
* @return		void
*/
function createPopupHtml(requestedMsg, numOfButton, buttonStr0, buttonStr1) {
	//alert ("createPopupHtml (requestedMsg, numOfButton, buttonStr0, buttonStr1)");
	MAX_MENU_NUM = eval(numOfButton) - 1;
	
	buttonName0 = "OK";
	buttonName1 = "Cancel";
	
	var tempHtml;
    
	// To make HTML for buttons
    if (numOfButton == 0) {
        tempHtml = "<table border = '0' width = '0px'><tr><td><a href='javascript: void(0)' id='noBt' onkeydown='javascript:popupNoBTKeyDown(this)'></td></tr></table>";
    } else {
    	if (numOfButton == 1)
    		tempHtml = "<table border = '0' width = '108px'>";
    	else if (numOfButton == 2)
    		tempHtml = "<table border = '0' width = '216px'>";
    
    	if (buttonStr0 != null) buttonName0 = buttonStr0;
    	tempHtml += "<tr><td align = 'right' valign = 'middle'>";
    	tempHtml += "<a href='javascript: void(0);' onkeydown='javascript:popupKeyDown(this);' onfocus='javascript:popupFocus(this);' onblur='javascript:popupBlur(this);' id = 'popupButton0' name = '0'>";
    	tempHtml += "<table width = '108px' height = '35px' border = '0'><tr><td align = 'center'>";
    	tempHtml += buttonName0;
    	tempHtml += "</td></tr></table></a></td>";
    	
    	// In case that there are two buttons
    	if (numOfButton == 2) {
    		if (buttonStr1 != null) {
    			buttonName1 = buttonStr1;
    		}
    		tempHtml += "<td align = 'right' valign = 'middle'>";
    		tempHtml += "<a href='javascript: void(0);' onkeydown='javascript:popupKeyDown(this);' onfocus='javascript:popupFocus(this);' onblur='javascript:popupBlur(this);' id = 'popupButton1' name = '1'>";
    		tempHtml += "<table width = '108px' height = '35px'><tr><td align = 'center'>";
    		tempHtml += buttonName1;
    		tempHtml += "</td></tr></table></a></td>";
    	}
    	tempHtml += "</tr></table><table><tr><td height = 5px></td></tr></table>";        
    }

	// Put buttons into 'msg' and 'buttonTable' div
	document.getElementById("popupMsg").innerHTML = requestedMsg;
	document.getElementById("popupButton").innerHTML = tempHtml;
}